<template>
  <div class="container h-100 d-flex justify-content-center align-items-center">
    <div class="col-lg-8">
      <h1 class="text-center mb-4">Expenses</h1>
     <!-- Button trigger modal -->
      <button type="button" class="btn btn-primary mb-3" @click="showModal = true">
        Create Expense
      </button>

       <!-- Modal -->
      <div class="modal" :class="{ 'd-block': showModal, 'show': showModal }" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">New Expense</h5>
              <button type="button" class="close" @click="showModal = false">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <p v-if="serverMessage" class="alert" :class="{ 'alert-success': !hasError, 'alert-danger': hasError }">{{ serverMessage }}</p>
              <!-- Add your form for creating an expense here -->
              <form @submit.prevent="createExpense">
                <div class="form-group">
                  <label for="title">Title</label>
                  <input v-model="newExpense.title" type="text" class="form-control" id="title" placeholder="Enter title">
                </div>
                <div class="form-group">
                  <label for="description">Description</label>
                  <textarea v-model="newExpense.description" class="form-control" id="description" rows="3"></textarea>
                </div>
                <div class="form-group">
                  <label for="amount">Amount</label>
                  <input v-model="newExpense.amount" type="number" class="form-control" id="amount" placeholder="Enter amount">
                </div>
                <div class="form-group">
                  <label for="date">Date</label>
                  <input v-model="newExpense.date" type="date" class="form-control" id="date">
                </div>
                <div class="form-group">
                  <label for="group">Group</label>
                  <select v-model="newExpense.groupId" class="form-control" id="group">
                    <option v-for="group in groups" :value="group.id">{{ group.name }}</option>
                  </select>
                </div>
                <button type="submit" class="btn btn-primary">Save changes</button>
              </form>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" @click="showModal = false">Close</button>
              
            </div>
          </div>
        </div>
      </div>
      <table class="table table-striped">
        <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Title</th>
            <th scope="col">Description</th>
            <th scope="col">Date</th>
            <th scope="col">Amount</th>
            <th scope="col">Status</th>
            <th scope="col">Actions</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(expense, index) in expenses" :key="expense.id">
            <th scope="row">{{ index + 1 }}</th>
            <td>{{ expense.title }}</td>
            <td>{{ expense.description }}</td>
            <td>{{ expense.date }}</td>
            <td>{{ expense.amount }}</td>
            <td>{{ expense.status }}</td>
            <td>
              <button class="btn btn-primary">Update</button>
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
</template>

<script>
import { GET_GROUPS,POST_EXPENSE, GET_EXPENSES_BY_OWNER, GET_GROUP_KEYS } from "../api/api.js";
import JSEncrypt from 'jsencrypt';
import CryptoJS from 'crypto-js';
export default {
  name: 'HomeView',
  data() {
    return {
      expenses: [],
      showModal: false,
      groups: [],
      serverMessage: '',
      newExpense: {
        title: "",
        description: "",
        date: "",
        amount: 0,
        paidBy: JSON.parse(sessionStorage.getItem("token")).id, // Replace this with the actual user ID
        groupId: null
      }, 
      currentUser: JSON.parse(sessionStorage.getItem('token')) // You should fetch the expenses from your API and assign them to this array
    }
  },
  methods:{
    createExpense() {
      // Sanitize inputs
    const sanitizedTitle = this.sanitizeInput(this.newExpense.title);
    const sanitizedDescription = this.sanitizeInput(this.newExpense.description);
       // Find the selected group
    const selectedGroup = this.groups.find(group => group.id === this.newExpense.groupId);
    if(selectedGroup && selectedGroup.decryptedKey){
       // Encrypt the expense data with the decrypted group key
    const encryptedExpense = {
      ...this.newExpense,
      title: CryptoJS.AES.encrypt(sanitizedTitle, selectedGroup.decryptedKey).toString(),
      description: CryptoJS.AES.encrypt(sanitizedDescription, selectedGroup.decryptedKey).toString(),
      date: CryptoJS.AES.encrypt(this.newExpense.date, selectedGroup.decryptedKey).toString(),
      // Do not encrypt the amount
      amount: this.newExpense.amount,
    };
    
      POST_EXPENSE(encryptedExpense)
        .then((data) => {
          console.log(encryptedExpense);
          // this.expenses.push(data);
          this.fetchExpenses();
          this.showModal = false;
          this.serverMessage = 'Expense created successfully';
          this.hasError = false;
        })
        .catch((e) => {
          console.log(e);
          this.serverMessage = 'Error creating expense';
          this.hasError = true;
        });
      } else {
        console.error('No decrypted key found for the selected group');
      }
    },
    fetchGroups() {
      GET_GROUPS()
        .then((data) => {
          this.groups = data.group;

          this.groups.forEach(group => {
            GET_GROUP_KEYS(group.id)
              .then((response) => {
                const groupKeys = response.groupKeys;
                console.log(response);
                const userGroupKey = groupKeys.find(key => key.userId === this.currentUser.id);
                console.log("keys",userGroupKey);
                if(userGroupKey){
                  const crypt = new JSEncrypt();
                  const privateKey = localStorage.getItem('privateKey');
                  crypt.setPrivateKey(privateKey);
                  const decryptedGroupKey = crypt.decrypt(userGroupKey.encryptedKey);
                  // Store the decrypted group key in the group object
                  group.decryptedKey = decryptedGroupKey;
                  console.log('localStorage:', privateKey);
                  console.log('decryptedGroupKey:', decryptedGroupKey);
                  

              if (!decryptedGroupKey) {
                console.error('Failed to decrypt group key for user', this.currentUser.id);
                return null;
              }
              // Decrypt the group name with the decrypted group key
              const decryptedGroupName = CryptoJS.AES.decrypt(group.name, decryptedGroupKey).toString(CryptoJS.enc.Utf8);
              console.log("name", decryptedGroupName);
              group.name = decryptedGroupName;
                }
              })
              .catch((e) => {
                console.error('Failed to fetch group keys',e);
              });
          });
          console.log(data.group)
        })
        .catch((e) => {
          console.log(e);
        });
    },
    fetchExpenses() {
      const userId = JSON.parse(sessionStorage.getItem("token")).id;
    GET_EXPENSES_BY_OWNER(userId)
    .then((data) => {
      console.log(data);
      // Decrypt the expenses
      const decryptedExpenses = data.map(expense => {
        // Fetch the group keys for the group of the expense
        return GET_GROUP_KEYS(expense.groupId)
          .then((response) => {
            const groupKeys = response.groupKeys;
            const userGroupKey = groupKeys.find(key => key.userId === this.currentUser.id);
            if(userGroupKey){
              const crypt = new JSEncrypt();
              const privateKey = localStorage.getItem('privateKey');
              crypt.setPrivateKey(privateKey);
              const decryptedGroupKey = crypt.decrypt(userGroupKey.encryptedKey);
              // Decrypt the expense data with the decrypted group key
              return {
                ...expense,
                title: CryptoJS.AES.decrypt(expense.title, decryptedGroupKey).toString(CryptoJS.enc.Utf8),
                description: CryptoJS.AES.decrypt(expense.description, decryptedGroupKey).toString(CryptoJS.enc.Utf8),
                date: CryptoJS.AES.decrypt(expense.date, decryptedGroupKey).toString(CryptoJS.enc.Utf8),
                // The amount is not encrypted
                amount: expense.amount,
              };
            } else {
              console.error('No decrypted key found for the group of the expense');
              return expense;
            }
          });
      });  
       // Wait for all expenses to be decrypted
       Promise.all(decryptedExpenses).then((expenses) => {
        this.expenses = expenses;
        console.log(expenses);
      });
    })
    .catch((e) => {
      console.log(e);
    });
  },
  sanitizeInput(input) {
    // Remove script tags, encode special characters, or use a library like DOMPurify
    return input.replace(/<script.*?>.*?<\/script>/gi, '').trim();
  },
  },
  async mounted(){
    await this.fetchGroups(),
    this.fetchExpenses()
  }
}
</script>

<style scoped>
.container {
  height: 100vh; /* Full height of the viewport */
}
</style>